import type { NextPage } from "next";
import Head from "next/head";
import { useCallback, useEffect } from "react";
import authTokenService from "core/services/authTokenService";
import redirectTo from "core/utils/redirectTo";
import TgAuth from "core/uikit/TgAuth/TgAuth";

import styles from "styles/pages/AuthPage.module.scss";
import { useDispatch } from "react-redux";
import { userAuth } from "core/redux/actions/auth";

const Home: NextPage = () => {
  // const router = useRouter()
  // const { credentials } = router.query

  const dispatch = useDispatch();
  // const {
  //   isAuthInProgress,
  //   authError
  // } = useSelector<IRootReducer, IAuthState>((store)=>store.auth);

  const onTgAuth = useCallback((userdata) => {
    dispatch(userAuth({
      ...userdata,
      userType: 'owner'
    }))
  }, [dispatch])

  useEffect(()=>{
    if(authTokenService.hasTokenInLocalstorage()) {
      redirectTo('/auth/user');
    }
  }, [])

  // const handleAuth = useCallback((formData)=>{
  //   dispatch(userAuth({
  //     email: formData.email,
  //     password: formData.password
  //   }))
  // }, [dispatch])

  // var {
  //   onChangeField,
  //   handleSubmit,
  //   formData
  // } = useForm(handleAuth, {
  //   email: (credentials as string)?.split(':')[0],
  //   password: (credentials as string)?.split(':')[1]
  // });

  // useEffect(()=>{
  //   if((credentials as string)?.split(':').length === 2 && formData.email && formData.password) {
  //     handleSubmit();
  //   }
  // }, [credentials, handleSubmit, formData])
  
  return (
    <div className={styles.page}>
      <Head>
        <title>Create Next App</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/favicon.ico" />
      </Head>
      <main className={styles.main}>
        <div className={styles.authCard}>
          {/* {isAuthInProgress && <div className={styles.authCard__loader}/>} */}
          <span className={styles.authCard__brand}>MD.Cafe</span>

          <div className={styles.authCard__content}>
            <div className={styles.authCard__contentInner}>
              <h1 className={styles.authCard__title}>Авторизация</h1>
              <h2 className={styles.authCard__subtitle}>Вход в панель управления</h2>
            </div>
            <hr />
            <div className={styles.authCard__contentInner}>
              <TgAuth onAuth={onTgAuth}/>
            </div>
          </div>

          <span className={styles.authCard__copy}>Powered by M.Dev</span>
        </div>
      </main>
    </div>
  );
};

export default Home;
